<template>
    <query-renderer :cubejs-api="cubejsApi" :query='query' v-if="cubejsApi">
        <template #default="{ resultSet }">
            <div class="chartSize">
                <IEcharts :option='display(resultSet)' />
            </div>
        </template>
        <template #empty> Loading... </template>
    </query-renderer>
</template>

<script>
import IEcharts from 'vue-echarts-v3/src/full.js';
import cubejs from '@cubejs-client/core';
import { QueryRenderer } from '@cubejs-client/vue';

const cubejsApi = cubejs('3cef9ce6789f3c0548109742d0b8eca3a5556b0be2b44c0f4b786e8a5a100063fff9f3d0c5e0095b34139a7ec55a1b71a3956ec49e4c92f7061f6b1556f8006e', {
  apiUrl: 'http://localhost:4000/cubejs-api/v1',
});

export default {
    name: 'BarChart',
    components: {
        IEcharts,
        QueryRenderer
    },

    data(){
        const query = {
        measures: ['Products.totalStock'],
        dimensions: ['Products.productType']
        };

        return {
            cubejsApi,
            query,
            seriesData: [],
            xAxisData: [],
            chartOption: {}
        }
    },

    methods: {
        display(resultSet) {
            const seriesNames = resultSet.seriesNames();
            const pivot = resultSet.chartPivot();
            seriesNames.forEach((e) => {
            this.seriesData = pivot.map((p) => p[e.key]);
            this.xAxisData = pivot.map((p) => p.x);
            });

            return this.chartOption= {
                legend: {},
                tooltip: {},
                series: [
                    {
                        type: 'bar',
                        data: this.seriesData,
                        color: ['rgba(75,192,192,0.6)']
                    }
                ],
                xAxis: {
                    type: 'category',
                    data: this.xAxisData,
                    name: 'Product Line',
                    nameLocation: 'middle',
                    nameTextStyle: {
                        padding: [20,0,0,0]
                    }
                },
                yAxis: {
                    type: 'value',
                    name: 'Quantity in Stock',
                    nameLocation: 'middle',
                    nameTextStyle: {
                        padding: [0,0,50,0]
                    }
                }
            }
      //console.log(this.seriesData)
        }
    }   
}
</script>

<style scoped>
    .chartSize{
        height: 350px;
        width: 800px;
        margin-left: 2rem;
    }
</style>